diff --git a/libr/anal/p/anal_arm_cs.c b/libr/anal/p/anal_arm_cs.c
index 6aaa06cbfb3..5b114b23b11 100644
--- a/libr/anal/p/anal_arm_cs.c
+++ b/libr/anal/p/anal_arm_cs.c
@@ -1422,6 +1422,7 @@ static int analop64_esil(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int l
 
 #define MATH32(opchar) arm32math(a, op, addr, buf, len, handle, insn, pcdelta, str, opchar, 0)
 #define MATH32_NEG(opchar) arm32math(a, op, addr, buf, len, handle, insn, pcdelta, str, opchar, 1)
+#define MATH32AS(opchar) arm32mathaddsub(a, op, addr, buf, len, handle, insn, pcdelta, str, opchar)
 
 static void arm32math(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int len, csh *handle, cs_insn *insn, int pcdelta, char (*str)[32], const char *opchar, int negate) {
 	const char *dest = ARG(0);
@@ -1457,7 +1458,28 @@ static void arm32math(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int len,
 	}
 }
 
+static void arm32mathaddsub(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int len, csh *handle, cs_insn *insn, int pcdelta, char (*str)[32], const char *opchar) {
+	const char *dst = ARG(0);
+	const char *src;
+	bool noflags = false;
+	if (!strcmp (dst, "pc")) {	//this is because strbuf_prepend doesn't exist and E_TOO_LAZY
+		r_strbuf_append (&op->esil, "$$,pc,=,");
+		noflags = true;
+	}
+	if (OPCOUNT() == 3) {
+		r_strbuf_appendf (&op->esil, "%s,%s,=,", ARG (1), dst);
+		src = ARG (2);
+	} else {
+		src = (!strcmp (ARG (1), "pc")) ? "$$" : ARG (1);
 
+	}
+	r_strbuf_appendf (&op->esil, "%s,%s,%s=", src, dst, opchar);
+	if (noflags) {
+		return;
+	}
+	r_strbuf_appendf (&op->esil, ",%%z,zf,=,%s,cf,=,vf,=,0,nf,=",
+			(!strcmp (opchar, "+") ? "%c30,%c31,^,%c31" : "%c30,%c31,^,%b32"));
+}
 
 static int analop_esil(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int len, csh *handle, cs_insn *insn, bool thumb) {
 	int i;
@@ -1503,14 +1525,14 @@ static int analop_esil(RAnal *a, RAnalOp *op, ut64 addr, const ut8 *buf, int len
 			//op->type = R_ANAL_OP_TYPE_RCJMP;
 			op->type = R_ANAL_OP_TYPE_UCJMP;
 		}
-		MATH32("+");
+		MATH32AS("+");
 		break;
 	case ARM_INS_SSUB16:
 	case ARM_INS_SSUB8:
 	case ARM_INS_SUBW:
 	case ARM_INS_SUB:
 		op->type = R_ANAL_OP_TYPE_ADD;
-		MATH32("-");
+		MATH32AS("-");
 		break;
 	case ARM_INS_MUL:
 		op->type = R_ANAL_OP_TYPE_MUL;
